(function(){
  var _, ref$, OrderedMap, Map, List, Observable, prepareProps, ModalsControllerInternal, ModalsController, defaultModalsController, this$ = this;
  _ = require('lodash');
  ref$ = require('immutable'), OrderedMap = ref$.OrderedMap, Map = ref$.Map, List = ref$.List;
  Observable = (function(){
    Observable.displayName = 'Observable';
    var prototype = Observable.prototype, constructor = Observable;
    Observable.prototype._obsSubscribers = Map().asMutable();
    Observable.prototype._obsUuid = 0;
    Observable.prototype.sub = function(it){
      var id, this$ = this;
      while (this._obsSubscribers.has(id = ++this._obsUuid % (Number.MAX_SAFE_INTEGER - 1))) {}
      this._obsSubscribers.set(id, it);
      return function(it){
        return it.bind(this$, id);
      }(function(id){
        this$._obsSubscribers.remove(id);
      });
    };
    Observable.prototype.notify = function(data){
      this._obsSubscribers.forEach(function(it){
        it(data);
      });
    };
    function Observable(){}
    return Observable;
  }());
  prepareProps = function(props, additional){
    var ref$;
    return ref$ = _.omit(props, ['modalsController', 'component']), ref$.modalData = additional, ref$;
  };
  ModalsControllerInternal = (function(superclass){
    var prototype = extend$((import$(ModalsControllerInternal, superclass).displayName = 'ModalsControllerInternal', ModalsControllerInternal), superclass).prototype, constructor = ModalsControllerInternal;
    ModalsControllerInternal.prototype.uid = 0;
    ModalsControllerInternal.prototype._windows = OrderedMap();
    Object.defineProperty(ModalsControllerInternal.prototype, 'windows', {
      get: function(){
        return this._windows;
      },
      set: function(w){
        if (this._windows !== w) {
          this.notify(this._windows = w);
        }
      },
      configurable: true,
      enumerable: true
    });
    ModalsControllerInternal.prototype.reg = function(component, props){
      var id, additional;
      while (this._windows.has(id = ++this.uid % (Number.MAX_SAFE_INTEGER - 1))) {}
      this.windows = this.windows.set(id, List([
        component, prepareProps(props, additional = {
          _debugId: id,
          needsDispose: false,
          didDisposed: this.childDidDisposed.bind(this, id)
        }), additional
      ]));
      return id;
    };
    ModalsControllerInternal.prototype.childDidDisposed = function(id){
      if (!this._windows.has(id)) {
        return;
      }
      this.windows = this.windows.remove(id);
    };
    ModalsControllerInternal.prototype.setModalProps = function(id, props){
      var this$ = this;
      if (!this._windows.has(id)) {
        return;
      }
      return this.windows = this.windows.update(id, function(it){
        var additional;
        additional = it.get(2);
        return it.update(1, function(){
          return prepareProps(props, {
            modalData: additional
          });
        });
      });
    };
    ModalsControllerInternal.prototype.disposeModal = function(id){
      var this$ = this;
      if (!this._windows.has(id)) {
        return;
      }
      return this.windows = this.windows.update(id, function(it){
        var additional, ref$;
        return it.set(2, additional = (ref$ = import$({}, it.get(2)), ref$.needsDispose = true, ref$)).update(1, (function(it){
          return it.modalData = additional, it;
        }));
      });
    };
    function ModalsControllerInternal(){
      ModalsControllerInternal.superclass.apply(this, arguments);
    }
    return ModalsControllerInternal;
  }(Observable));
  ModalsController = (function(){
    ModalsController.displayName = 'ModalsController';
    var prototype = ModalsController.prototype, constructor = ModalsController;
    ModalsController.prototype._internal = new ModalsControllerInternal();
    ModalsController.prototype.count = function(){
      return this._internal.windows.size;
    };
    function ModalsController(){}
    return ModalsController;
  }());
  defaultModalsController = function(it){
    return it.bind({});
  }(function(){
    var ref$;
    return (ref$ = this.defaultModalsController) != null
      ? ref$
      : this.defaultModalsController = new ModalsController();
  });
  module.exports = {
    defaultModalsController: defaultModalsController,
    ModalsController: ModalsController
  };
  function extend$(sub, sup){
    function fun(){} fun.prototype = (sub.superclass = sup).prototype;
    (sub.prototype = new fun).constructor = sub;
    if (typeof sup.extended == 'function') sup.extended(sub);
    return sub;
  }
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
