(function(){
  var _, react, Component, defaultModalsController, ref$, Map, List, OrderedMap, RestrictedUpdationComponent, RestrictedUpdationComponentClass, ModalWrap, ModalWrapClass, Modals, ModalsClass;
  _ = require('lodash');
  react = require('react'), Component = react.Component;
  defaultModalsController = require('./controller').defaultModalsController;
  ref$ = require('immutable'), Map = ref$.Map, List = ref$.List, OrderedMap = ref$.OrderedMap;
  RestrictedUpdationComponent = react.createFactory(RestrictedUpdationComponentClass = (function(superclass){
    var prototype = extend$((import$(RestrictedUpdationComponentClass, superclass).displayName = 'RestrictedUpdationComponentClass', RestrictedUpdationComponentClass), superclass).prototype, constructor = RestrictedUpdationComponentClass;
    RestrictedUpdationComponentClass.prototype.shouldComponentUpdate = function(){
      var this$ = this;
      return _.some({
        data: arguments[0].data
      }, function(){
        return this$.props[arguments[1]] !== arguments[0];
      });
    };
    RestrictedUpdationComponentClass.prototype.render = function(){
      var data;
      data = this.props.data;
      return react.createElement(data.get(0), data.get(1));
    };
    function RestrictedUpdationComponentClass(){
      RestrictedUpdationComponentClass.superclass.apply(this, arguments);
    }
    return RestrictedUpdationComponentClass;
  }(Component)));
  ModalWrap = react.createFactory(ModalWrapClass = (function(superclass){
    var prototype = extend$((import$(ModalWrapClass, superclass).displayName = 'ModalWrapClass', ModalWrapClass), superclass).prototype, constructor = ModalWrapClass;
    ModalWrapClass.prototype.shouldComponentUpdate = function(){
      var ref$, this$ = this;
      return _.some({
        data: (ref$ = arguments[0]).data,
        disabled: ref$.disabled,
        fieldsetStyle: ref$.fieldsetStyle
      }, function(){
        return this$.props[arguments[1]] !== arguments[0];
      });
    };
    ModalWrapClass.prototype.render = function(){
      var ref$, data, fieldsetStyle, disabled;
      ref$ = this.props, data = ref$.data, fieldsetStyle = ref$.fieldsetStyle, disabled = ref$.disabled;
      return react.createElement('fieldset', {
        style: fieldsetStyle,
        disabled: disabled
      }, RestrictedUpdationComponent({
        data: data
      }));
    };
    function ModalWrapClass(){
      ModalWrapClass.superclass.apply(this, arguments);
    }
    return ModalWrapClass;
  }(Component)));
  Modals = react.createFactory(ModalsClass = (function(superclass){
    var prototype = extend$((import$(ModalsClass, superclass).displayName = 'ModalsClass', ModalsClass), superclass).prototype, constructor = ModalsClass;
    function ModalsClass(){
      var ref$;
      ModalsClass.superclass.apply(this, arguments);
      this.ctrlr = (ref$ = this.props.controller) != null
        ? ref$
        : defaultModalsController();
      this.defaultFieldsetStyle = {
        border: 'none',
        outline: 'none'
      };
      this.fieldsetStyle = this.getFieldsetStyle(this.props.fieldsetStyle);
      this.root = List([this.props.root, null]);
      this.state = {
        windows: this.ctrlr._internal.windows
      };
    }
    ModalsClass.prototype.shouldComponentUpdate = function(){
      var ref$, this$ = this;
      return _.some({
        windows: (ref$ = arguments[1]).windows,
        fieldsetStyle: ref$.fieldsetStyle,
        root: ref$.root
      }, function(){
        return this$.state[arguments[1]] !== arguments[0];
      });
    };
    ModalsClass.prototype.componentWillMount = function(){
      var this$ = this;
      this.unsub = this.ctrlr._internal.sub(function(it){
        this$.setState({
          windows: it
        });
      });
    };
    ModalsClass.prototype.componentWillUnmount = function(){
      if (typeof this.unsub == 'function') {
        this.unsub();
      }
    };
    ModalsClass.prototype.componentWillReceiveProps = function(){
      var ref$, fieldsetStyle, controller, root;
      ref$ = this.props, fieldsetStyle = ref$.fieldsetStyle, controller = ref$.controller, root = ref$.root;
      if (controller !== arguments[0].controller) {
        throw 'Modals controller can not be changed after initializing';
      }
      if (fieldsetStyle !== arguments[0].fieldsetStyle) {
        this.fieldsetStyle = this.getFieldsetStyle(fieldsetStyle);
      }
      if (root !== arguments[0].root) {
        this.root = List([this.props.root, null]);
      }
    };
    ModalsClass.prototype.getFieldsetStyle = function(it){
      switch (false) {
      case it != null:
        return this.defaultFieldsetStyle;
      case !_.isFunction(it):
        return it(this.defaultFieldsetStyle);
      case !_.isObject(it):
        return it;
      }
    };
    ModalsClass.prototype.render = function(){
      var windows, fieldsetStyle, root, idx;
      windows = this.state.windows, fieldsetStyle = this.fieldsetStyle, root = this.root;
      return react.createElement('div', _.omit(this.props, ['fieldsetStyle', 'controller', 'root']), [ModalWrap({
        key: '_',
        fieldsetStyle: fieldsetStyle,
        disabled: windows.size,
        data: root
      })].concat((idx = 0, windows.map(function(){
        return ModalWrap({
          key: arguments[1],
          fieldsetStyle: fieldsetStyle,
          disabled: idx++ !== arguments[2].size - 1,
          data: arguments[0]
        });
      }).valueSeq())));
    };
    return ModalsClass;
  }(Component)));
  module.exports = {
    Modals: Modals
  };
  function extend$(sub, sup){
    function fun(){} fun.prototype = (sub.superclass = sup).prototype;
    (sub.prototype = new fun).constructor = sub;
    if (typeof sup.extended == 'function') sup.extended(sub);
    return sub;
  }
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
